/*************************************************************************

         name: exampleModels.pl (Chapter 1)
      version: March 9, 1999
  description: Some example models defined over a vocabulary
      authors: Patrick Blackburn & Johan Bos
 
*************************************************************************/

:- module(exampleModels,[constant/1,relation/2,example/2]).

/*========================================================================
   Vocabulary
========================================================================*/

relation(love,2).             
relation(hate,2).             
relation(tell,2). 
relation(episode,2). 
relation(in,2).             
relation(customer,1).         
relation(robber,1).           
relation(joke,1). 
relation(woman,1). 
relation(man,1).           

constant(mia).
constant(vincent).
constant(honey_bunny).
constant(pumpkin).
constant(jules). 
constant(jody).
constant(j1). 
constant(j2). 
constant(e15). 
constant(e13).


/*========================================================================
   Example Models
========================================================================*/

example(1,[customer(mia),customer(vincent),
           robber(pumpkin),robber(honey_bunny),
           love(pumpkin,honey_bunny)]).

example(2,[customer(mia),
           robber(pumpkin),robber(honey_bunny),
           love(pumpkin,honey_bunny)]).

example(3,[customer(mia),customer(vincent),
           robber(pumpkin),robber(honey_bunny),
           love(pumpkin,honey_bunny),love(mia,vincent)]).

example(4,[woman(mia),
           man(vincent),man(jules),
           joke(j1),joke(j2),
           in(j1,e15),
           episode(e13),episode(e15),
           tell(mia,j1)]).

example(5,[woman(mia),woman(jody),
           man(vincent),man(jules),
           joke(j1),joke(j2),
           in(j1,e15),in(j1,e13),
           episode(e13),episode(e15),
           tell(mia,j1),tell(jody,j2)]).




