/*************************************************************************

         name: mainDRTU.pl (Chapter 8)
      version: May 28, 1998
  description: Plugging Stuff for Underspecified DRSs
       author: Patrick Blackburn & Johan Bos
 
*************************************************************************/

:- module(mainDRTU,[parse/0]).

:- use_module(readLine,[readLine/1]),
   use_module(comsemOperators),
   use_module(betaConversion,[betaConvert/2]),
   use_module(pluggingAlgorithm,[plugHole/4]),
   use_module(mergeDRT,[mergeDrs/2]),
   use_module(mergeUSR,[mergeUSR/2]),
   use_module(comsemPredicates,[append/3,printRepresentation/1,
                                printReadings/1,compose/3]).

:- [englishGrammar], [englishLexicon], [semMacrosDRTU].

/*========================================================================
   Driver Predicate
========================================================================*/

parse:-
   readLine(Sentence),
   d(Sem,Sentence,[]),
   betaConvert(merge(usr([Top,Main],[],[]),Sem@Top@Main),Reduced),
   mergeUSR(Reduced,usr(D,L,C)),
   printRepresentation(usr(D,L,C)),
   findall(Drs,(plugHole(Top,L-[],C,[]),mergeDrs(Top,Drs)),DRSs),
   printReadings(DRSs).
