/*************************************************************************

         name: mainLambdaDRT.pl (Chapter 8)
      version: March 22, 1999
  description: Semantic Construction with Beta Conversion for DRT
      authors: Patrick Blackburn & Johan Bos
 
*************************************************************************/

:- module(mainLambdaDRT,[parse/0]).

:- use_module(readLine,[readLine/1]),
   use_module(comsemOperators),
   use_module(comsemPredicates,[printRepresentation/1,compose/3]),
   use_module(betaConversion,[betaConvert/2]),
   use_module(mergeDRT,[mergeDrs/2]).

:- [englishGrammar], [englishLexicon], [semMacrosLambdaDRT].

/*========================================================================
   Driver Predicate
========================================================================*/

parse:-
   readLine(Discourse),
   statistics(walltime,_),
   d(MergeDrs,Discourse,[]),
   betaConvert(MergeDrs,ReducedDrs),
   mergeDrs(ReducedDrs,Drs),
   statistics(walltime,[_,Time]),
   nl, write(Time),
   printRepresentation(Drs).


