/*************************************************************************

         name: mainPLU.pl (Chapter 3)
      version: Jan 31, 1998
  description: Predicate Logic Unplugged
       author: Patrick Blackburn & Johan Bos
 
*************************************************************************/

:- module(mainPLU,[parse/0]).

:- use_module(readLine,[readLine/1]),
   use_module(comsemOperators),
   use_module(betaConversion,[betaConvert/2]),
   use_module(pluggingAlgorithm,[plugHole/4]),
   use_module(mergeUSR,[mergeUSR/2]),
   use_module(comsemPredicates,[append/3,printRepresentation/1,
                                printReadings/1,compose/3]).

:- [englishGrammar], [englishLexicon], [semMacrosPLU].



/*========================================================================
   Driver Predicate
========================================================================*/

parse:-
   readLine(Sentence),
   d(Sem,Sentence,[]), 
   betaConvert(merge(usr([Top,Main],[],[]),Sem@Top@Main),Reduced),
   mergeUSR(Reduced,usr(D,L,C)),
   printRepresentation(usr(D,L,C)),
   findall(Top,plugHole(Top,L-[],C,[]),Readings),
   printReadings(Readings).
