/**********************************************************************

         name: mainPresupDRT.pl
      version: May 5, 1998
  description: Presupposition Projection 
      authors: Patrick Blackburn & Johan Bos

**********************************************************************/

:- module(mainPresupDRT,[parse/0,projectDrs/1]).

:- use_module(readLine,[readLine/1]),
   use_module(comsemOperators),
   use_module(comsemPredicates,[printReadings/1,compose/3]),
   use_module(betaConversion,[betaConvert/2]),
   use_module(resolvePresup,[projectDrs/1,accommodate/2]).

:- [englishGrammar], [englishLexicon], [semMacrosPresupDRT].


/*========================================================================
   Driver Predicate
========================================================================*/

parse:-
   readLine(Discourse),
   d(Drs1,Discourse,[]),
   betaConvert(Drs1,Drs2),
   findall(Drs4,(
		 projectDrs([Drs2,pre([])]-[Drs3,pre(P)]),
		 accommodate(P,Drs3-Drs4)
		),
	   Readings),
   printReadings(Readings).

