/*************************************************************************

         name: mainPresupDRTU.pl (Chapter 12)
      version: May 28, 1998
  description: Combining DRTU with presupposition resolution
       author: Patrick Blackburn & Johan Bos
 
*************************************************************************/

:- module(mainPresupDRTU,[parse/0]).

:- use_module(readLine,[readLine/1]),
   use_module(comsemOperators),
   use_module(comsemPredicates,[printRepresentation/1,
				printReadings/1,compose/3]),
   use_module(betaConversion,[betaConvert/2]),
   use_module(pluggingAlgorithm,[plugHole/4]),
   use_module(mergeDRT,[mergeDrs/2]),
   use_module(mergeUSR,[mergeUSR/2]),
   use_module(resolvePresup,[projectDrs/1,accommodate/2]).

:- [englishGrammar], [englishLexicon], [semMacrosPresupDRTU].

/*========================================================================
   Driver Predicate
========================================================================*/

parse:-
   readLine(Discourse),
   d(Sem,Discourse,[]),
   betaConvert(merge(usr([Top,Main],[],[]),Sem@Top@Main),Reduced),
   mergeUSR(Reduced,usr(D,L,C)),
   printRepresentation(usr(D,L,C)),
   findall(Drs,
	       (   
		plugHole(Top,L-[],C,[]),
		projectDrs([Top,pre([])]-[PresupDrs,pre(P)]),
		accommodate(P,PresupDrs-Drs)
	       ),
	   Readings),
   printReadings(Readings).
