/**********************************************************************

         name: mainPresupScoreDRT.pl
      version: Feb 6, 1999
  description: Presupposition Resolution with Score Calculation
      authors: Patrick Blackburn & Johan Bos

**********************************************************************/

:- module(mainPresupScoreDRT,[parse/0,projectDrs/1]).

:- use_module(readLine,[readLine/1]),
   use_module(comsemOperators),
   use_module(comsemPredicates,[printReadings/1,compose/3]),
   use_module(betaConversion,[betaConvert/2]),
   use_module(resolvePresupScore,[projectDrs/2,accommodate/2]).

:- [englishGrammar], [englishLexicon], [semMacrosPresupDRT].

/*========================================================================
   Driver Predicate
========================================================================*/

parse:-
   readLine(Discourse),
   d(Drs1,Discourse,[]),
   betaConvert(Drs1,Drs2),
   findall((Score:Drs4),(
		 projectDrs([Drs2,pre([])]-[Drs3,pre(P)],1-Score),
		 accommodate(P,Drs3-Drs4)
		),
	   Readings),
   printReadings(Readings).
