/*************************************************************************

         name: mergeDRT.pl (Chapter 8)
      version: June 9, 1998
  description: Definition of the merge for DRSs
      authors: Patrick Blackburn & Johan Bos
 
*************************************************************************/

:- module(mergeDRT,[mergeDrs/2]).

:- use_module(comsemOperators),
   use_module(comsemPredicates,[append/3]).

/*========================================================================
   DRS-merge
========================================================================*/

mergeDrs(drs(D,C1),drs(D,C2)):-
   mergeDrs(C1,C2).
mergeDrs(merge(B1,B2),drs(D3,C3)):-
   mergeDrs(B1,drs(D1,C1)), mergeDrs(B2,drs(D2,C2)),
   append(D1,D2,D3), append(C1,C2,C3).
mergeDrs([B1 > B2|C1],[B3 > B4|C2]):- !,
   mergeDrs(B1,B3), mergeDrs(B2,B4), mergeDrs(C1,C2).
mergeDrs([B1 v B2|C1],[B3 v B4|C2]):- !,
   mergeDrs(B1,B3), mergeDrs(B2,B4), mergeDrs(C1,C2).
mergeDrs([~ B1|C1],[~ B2|C2]):- !,
   mergeDrs(B1,B2), mergeDrs(C1,C2).
mergeDrs([C|C1],[C|C2]):-
   mergeDrs(C1,C2).
mergeDrs([],[]).

