/*************************************************************************

         name: mergeUSR.pl (Chapter 3)
      version: June 18, 1999
  description: Definition of the merge for USRs
      authors: Patrick Blackburn & Johan Bos
 
*************************************************************************/

:- module(mergeUSR,[mergeUSR/2]).

:- use_module(comsemPredicates,[append/3]).

/*========================================================================
   Merge for Underspecified Semantic Representations
========================================================================*/

mergeUSR(usr(D,L,C),usr(D,L,C)).

mergeUSR(merge(U1,U2),usr(D3,L3,C3)):-
   mergeUSR(U1,usr(D1,L1,C1)),
   mergeUSR(U2,usr(D2,L2,C2)),
   append(D1,D2,D3),
   append(L1,L2,L3),
   append(C1,C2,C3).


