/*************************************************************************

         name: semMacrosDRTU.pl (Chapter 8)
      version: May 28, 1998
  description: Semantic Macros for DRT Unplugged
       author: Patrick Blackburn & Johan Bos
 
*************************************************************************/

/*========================================================================
   Semantic Macros
========================================================================*/

detSem(uni,lambda(P,lambda(Q,lambda(H,lambda(L,
       merge(merge(usr([F,R,S],
		       [F:drs([],[merge(drs([X],[]),R)>S])],
		       [leq(F,H),leq(L,S)]),P@X@H@R),Q@X@H@L)))))).

detSem(indef,lambda(P,lambda(Q,lambda(H,lambda(L,
       merge(merge(usr([E,R,S],
		       [E:merge(merge(drs([X],[]),R),S)],
		       [leq(E,H),leq(L,S)]),P@X@H@R),Q@X@H@L)))))).

nounSem(Sym,lambda(X,lambda(_,lambda(L,usr([],[L:drs([],[Cond])],[]))))):-
   compose(Cond,Sym,[X]).

pnSem(Sym,_,lambda(P,lambda(H,lambda(M,
      merge(usr([L],[M:merge(drs([X],[X=Sym]),L)],[leq(M,H)]),
	    P@X@H@L))))).

proSem(_,_,lambda(P,lambda(H,lambda(M,
       merge(usr([L],[M:merge(drs([X],[]),L)],[leq(M,H)]),
	     P@X@H@L))))).

ivSem(Sym,lambda(X,lambda(_,lambda(L,
      usr([],[L:drs([],[Cond])],[]))))):-
   compose(Cond,Sym,[X]).

tvSem(Sym,lambda(K,lambda(Y,K@lambda(X,lambda(_,lambda(L,
      usr([],[L:drs([],[Cond])],[]))))))):-
   compose(Cond,Sym,[Y,X]).

relproSem(lambda(P,lambda(Q,lambda(X,lambda(H,lambda(L,
          merge(usr([L2,L3,H1] ,
                    [L:merge(L3,H1)],
                    [leq(L2,H1)]),
                merge(P@X@H@L2,Q@X@H@L3)))))))).

prepSem(Sym,lambda(K,lambda(P,lambda(Y,lambda(H,lambda(L3,
        merge(K@lambda(X,lambda(H,lambda(L1,
              usr([L2,H1],
		  [L3:merge(L2,H1),L1:drs([],[Cond])],
                  [leq(L1,H1)]))))@H@L1,P@Y@H@L2))))))):- 
   compose(Cond,Sym,[Y,X]).

modSem(neg,lambda(P,lambda(X,lambda(H,lambda(L,
       merge(usr([N,S],[N:drs([],[~S])],[leq(N,H),leq(L,S)]),
	     P@X@H@L)))))).

coordSem(conj,lambda(X,lambda(Y,lambda(P,lambda(H,lambda(L,
         merge(usr([L1,L2],[L:merge(L1,L2)],[leq(L,H)]),
               merge(X@P@H@L1,Y@P@H@L2)))))))).

coordSem(disj,lambda(X,lambda(Y,lambda(P,lambda(H,lambda(L,
         merge(usr([L1,L2],[L:drs([],[L1 v L2])],[leq(L,H)]),
               merge(X@P@H@L1,Y@P@H@L2)))))))).

dcoordSem(cond,lambda(C1,lambda(C2,lambda(H,lambda(L,
          merge(usr([H1,H2],[L:drs([],[H1 > H2])],[leq(L,H)]),
                merge(C1@H1@_,C2@H2@_))))))).

dcoordSem(conj,lambda(C1,lambda(C2,lambda(H,lambda(L,
          merge(usr([H1,H2],[L:merge(H1,H2)],[leq(L,H)]),
                merge(C1@H1@_,C2@H2@_))))))).

dcoordSem(disj,lambda(C1,lambda(C2,lambda(H,lambda(L,
          merge(usr([H1,H2],[L:drs([],[H1 v H2])],[leq(L,H)]),
                merge(C1@H1@_,C2@H2@_))))))).
