/*************************************************************************

         name: semMacroslambdaDRT.pl (Chapter 8)
      version: June 9, 1998
  description: Compositional DRS construction for a fragment of English
      authors: Patrick Blackburn & Johan Bos
 
*************************************************************************/

/*========================================================================
   Semantic Macros
========================================================================*/

detSem(uni,lambda(P,lambda(Q,drs([],[merge(drs([X],[]),P@X)>(Q@X)])))).
detSem(indef,lambda(P,lambda(Q,merge(merge(drs([X],[]),P@X),Q@X)))).

nounSem(Sym,lambda(X,drs([],[Cond]))):- 
   compose(Cond,Sym,[X]).

pnSem(Sym,Gender,lambda(P,merge(drs([X],[Cond,X=Sym]),P@X))):-
   compose(Cond,Gender,[X]).

proSem(Gender,Type,lambda(P,alfa(X,Type,Cond,P@X))):-
   compose(Cond,Gender,[X]).

ivSem(Sym,lambda(X,drs([],[Cond]))):- 
   compose(Cond,Sym,[X]).

tvSem(Sym,lambda(K,lambda(Y,K @ lambda(X,drs([],[Cond]))))):- 
   compose(Cond,Sym,[Y,X]).

relproSem(lambda(P1,lambda(P2,lambda(X,merge(P1@X,P2@X))))).

prepSem(Sym,lambda(K,lambda(P,lambda(Y,Drs)))):-   
   Drs=merge(K@lambda(X,drs([],[Cond])),P@Y), 
   compose(Cond,Sym,[Y,X]).

modSem(neg,lambda(P,lambda(X,drs([],[~(P @ X)])))).

coordSem(conj,lambda(X,lambda(Y,lambda(P,merge(X@P,Y@P))))).
coordSem(disj,lambda(X,lambda(Y,lambda(P,drs([],[(X@P) v (Y@P)]))))).

dcoordSem(cond,lambda(X,lambda(Y,drs([],[X > Y])))).
dcoordSem(conj,lambda(X,lambda(Y,merge(X,Y)))).
dcoordSem(disj,lambda(X,lambda(Y,drs([],[X v Y])))).

