/*************************************************************************

         name: semMacrosPresupDRTU.pl (Chapter 12)
      version: June 18, 1999
  description: Semantic Macros for DRTU with Presupposition Resolution
       author: Patrick Blackburn & Johan Bos
 
*************************************************************************/

/*========================================================================
   Semantic Macros
========================================================================*/

detSem(uni,lambda(P,lambda(Q,lambda(H,lambda(L,
       merge(merge(usr([F,R,S],
		       [F:drs([],[merge(drs([X],[]),R)>S])],
		       [leq(F,H),leq(L,S)]),P@X@H@R),Q@X@H@L)))))).

detSem(indef,lambda(P,lambda(Q,lambda(H,lambda(L,
       merge(merge(usr([E,R,S],
		       [E:merge(merge(drs([X],[]),R),S)],
		       [leq(E,H),leq(L,S)]),P@X@H@R),Q@X@H@L)))))).

detSem(def,lambda(P,lambda(Q,lambda(H,lambda(L,
       merge(merge(usr([R,S],
                       [L:alfa(X,def,merge(drs([X],[]),R),S)],
		       [leq(L,H)]),P@X@H@R),Q@X@H@S)))))).

detSem(poss(Gender),lambda(P,lambda(Q,lambda(H,lambda(L,
       merge(merge(usr([R,S],
                       [L:alfa(X,def,alfa(Y,nonrefl,drs([Y],[Cond]),
					  merge(drs([X],[of(X,Y)]),R)),S)],
                       [leq(L,H)]),P@X@H@R),Q@X@H@S)))))):-
   compose(Cond,Gender,[Y]).

nounSem(Sym,lambda(X,lambda(_,lambda(L,usr([],[L:drs([],[Cond])],[]))))):-
   compose(Cond,Sym,[X]).

pnSem(Sym,Gender,lambda(P,lambda(H,lambda(L,
      merge(usr([S],
		[L:alfa(X,name,drs([X],[X=Sym,Cond]),S)],
		[leq(L,H)]),
	    P@X@H@S))))):-
   compose(Cond,Gender,[X]).

proSem(Gender,Type,lambda(P,lambda(H,lambda(L,
      merge(usr([S],
		[L:alfa(X,Type,drs([X],[Cond]),S)],
		[leq(L,H)]),
	    P@X@H@S))))):-
   compose(Cond,Gender,[X]).

ivSem(Sym,lambda(X,lambda(_,lambda(L,
      usr([],[L:drs([],[Cond])],[]))))):-
   compose(Cond,Sym,[X]).

tvSem(Sym,lambda(K,lambda(Y,K@lambda(X,lambda(_,lambda(L,
      usr([],[L:drs([],[Cond])],[]))))))):-
   compose(Cond,Sym,[Y,X]).

relproSem(lambda(P,lambda(Q,lambda(X,lambda(H,lambda(L,
          merge(usr([L2,L3,H1] ,
                    [L:merge(L3,H1)],
                    [leq(L2,H1)]),
                merge(P@X@H@L2,Q@X@H@L3)))))))).

prepSem(Sym,lambda(K,lambda(P,lambda(Y,lambda(H,lambda(L3,
        merge(K@lambda(X,lambda(H,lambda(L1,
              usr([L2,H1],
		  [L3:merge(L2,H1),L1:drs([],[Cond])],
                  [leq(L1,H1)]))))@H@L1,P@Y@H@L2))))))):- 
   compose(Cond,Sym,[Y,X]).

modSem(neg,lambda(P,lambda(X,lambda(H,lambda(L,
       merge(usr([N,S],[N:drs([],[~S])],[leq(N,H),leq(L,S)]),
	     P@X@H@L)))))).

coordSem(conj,lambda(X,lambda(Y,lambda(P,lambda(H,lambda(L,
         merge(usr([L1,L2],[L:merge(L1,L2)],[leq(L,H)]),
               merge(X@P@H@L1,Y@P@H@L2)))))))).

coordSem(disj,lambda(X,lambda(Y,lambda(P,lambda(H,lambda(L,
         merge(usr([L1,L2],[L:drs([],[L1 v L2])],[leq(L,H)]),
               merge(X@P@H@L1,Y@P@H@L2)))))))).

dcoordSem(cond,lambda(C1,lambda(C2,lambda(H,lambda(L,
          merge(usr([H1,H2],[L:drs([],[H1 > H2])],[leq(L,H)]),
                merge(C1@H1@_,C2@H2@_))))))).

dcoordSem(conj,lambda(C1,lambda(C2,lambda(H,lambda(L,
          merge(usr([H1,H2],[L:merge(H1,H2)],[leq(L,H)]),
                merge(C1@H1@_,C2@H2@_))))))).

dcoordSem(disj,lambda(C1,lambda(C2,lambda(H,lambda(L,
          merge(usr([H1,H2],[L:drs([],[H1 v H2])],[leq(L,H)]),
                merge(C1@H1@_,C2@H2@_))))))).
